//Author S. Steer, Copyright INRIA
//Dense storage
//---------------

//1 - Real case

//1.1 general
A=matrix(1:12,3,4);
mmwrite(TMPDIR+'/A.mtx',A) ; 
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'real'|symm<>'general'|norm(A1-A)>10*%eps then pause,end


//1.2 symetric
A=A'*A;
mmwrite(TMPDIR+'/A.mtx',A); 
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'real'|symm<>'symmetric'|norm(A1-A)>10*%eps then pause,end

//1.3 skewsymetric
A=A-2*triu(A,1);
mmwrite(TMPDIR+'/A.mtx',A)  ;
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'real'|symm<>'skew-symmetric'|norm(A1-A)>10*%eps then pause,end

//2 Complex case

//2.1 general
A=matrix(1:12,3,4);A(1,2)=A(1,2)+%i
mmwrite(TMPDIR+'/A.mtx',A) ; 
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'complex'|symm<>'general'|norm(A1-A)>10*%eps then pause,end

//2.2 symetric
A=A.'*A;
mmwrite(TMPDIR+'/A.mtx',A);  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'complex'|symm<>'symmetric'|norm(A1-A)>10*%eps then pause,end


//2.3 skewsymetric
A=A-2*triu(A,1);
mmwrite(TMPDIR+'/A.mtx',A)  ;
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'complex'|symm<>'skew-symmetric'|norm(A1-A)>10*%eps then pause,end



//2.4 hermitian
A=matrix(1:12,3,4);A(1,2)=A(1,2)+%i
A=A'*A;
mmwrite(TMPDIR+'/A.mtx',A);  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'complex'|symm<>'hermitian'|norm(A1-A)>10*%eps then pause,end


//Sparse storage
//---------------

//1 - Real case

//1.1 general
A=sparse(matrix([0,0,3,4,0,0,0,8,9,0,11,0],3,4));
mmwrite(TMPDIR+'/A.mtx',A) ; 
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'real'|symm<>'general'|norm(A1-A)>10*%eps then pause,end

mmwrite(TMPDIR+'/A.mtx',A,[],'pattern')
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
A2=A;A2(find(A2<>0))=1;
if rep<>"coordinate"|field<>'pattern'|symm<>'general'|norm(A1-A2)>10*%eps then pause,end

//1.2 symetric
A=A'*A;
mmwrite(TMPDIR+'/A.mtx',A);  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'real'|symm<>'symmetric'|norm(A1-A)>10*%eps then pause,end

mmwrite(TMPDIR+'/A.mtx',A,[],'pattern');  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
A2=A;A2(find(A2<>0))=1;
if rep<>"coordinate"|field<>'pattern'|symm<>'symmetric'|norm(A1-A2)>10*%eps then pause,end


//1.3 skewsymetric
A=A-2*triu(A,1);
mmwrite(TMPDIR+'/A.mtx',A)  ;
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'real'|symm<>'skew-symmetric'|norm(A1-A)>10*%eps then pause,end

mmwrite(TMPDIR+'/A.mtx',A,[],'pattern')  ;
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
A2=A;A2(find(A2<>0))=1;
if rep<>"coordinate"|field<>'pattern'|symm<>'skew-symmetric'|norm(A1-A2)>10*%eps then pause,end


//2 Complex case

//2.1 general
A=sparse(matrix([0,0,3,4,0,0,0,8,9,0,11,0],3,4));A(1,2)=A(1,2)+%i;
mmwrite(TMPDIR+'/A.mtx',A) ; 
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'complex'|symm<>'general'|norm(A1-A)>10*%eps then pause,end


//2.2 symetric
A=A.'*A;
mmwrite(TMPDIR+'/A.mtx',A);  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'complex'|symm<>'symmetric'|norm(A1-A)>10*%eps then pause,end

//2.3 skewsymetric
A=A-2*triu(A,1);
mmwrite(TMPDIR+'/A.mtx',A)  ;
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'complex'|symm<>'skew-symmetric'|norm(A1-A)>10*%eps then pause,end



//2.4 hermitian
A=sparse(matrix([0,0,3,4,0,0,0,8,9,0,11,0],3,4));
A=A'*A;A(1,3)=A(1,3)+%i;A(3,1)=A(3,1)-%i;
mmwrite(TMPDIR+'/A.mtx',A);  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'complex'|symm<>'hermitian'|norm(A1-A)>10*%eps then pause,end


//test with files downloaded from http://math.nist.gov/MatrixMarket

F=listfiles("*.mtx')'
for f=F, disp(f),mmread(f);end
